
##
# CR-MP Start/Stop Script
#
# Author :	Andrey Chikaev (vk.com/winchikplay)
# Date	:	18 October 2020
##

#!/bin/bash
Infon() { printf "\033[1;32m$@\033[0m"; }
Info() { Infon "\031$@\n"; }
Error() { printf "\033[1;31m$@\033[0m\n"; }
Error_n() { Error "$@"; }
Error_s() { Error "${red}===========================================================${reset}"; }
log_s() { Info "${green}=========================================================== ${reset}"; }
cp_s () { Info "${green}===================${white}BY HACKCHIK${green}======================${reset}"; }
log_n() { Info "- - - $@"; }
log_t() { log_s; Info "- - - $@ - - -"; log_s; }
RED=$(tput setaf 1); red=$(tput setaf 1); green=$(tput setaf 2); yellow=$(tput setaf 3); white=$(tput setaf 7); reset=$(tput sgr0); toend=$(tput hpa $(tput cols))$(tput cub 6); YELLOW=$(tput setaf 3); BLUE=$(tput setaf 4); MAGENTA=$(tput setaf 5); LIME_YELLOW=$(tput setaf 190); CYAN=$(tput setaf 6);

# Config
DIR="/home/DIRTYPE/DIRNAME" 			# Директория сервера
EXEC="samp03svr"			# Серверное ядро
SCREENNAME="DIRNAME" 			# Названия задачи(Screen Name)
DESC="${white}Сервер ${MAGENTA}SERVNAME${white}"	# Описание

# Functions
function startServer 
{
	if [ -d $DIR ]; then
		cd $DIR
		if [ -f $EXEC ]; then
			screen -dmS $SCREENNAME ./$EXEC
			echo "$DESC ${green}запущен !${white}"
		else
			echo "${red}Ошибка: ${MAGENTA}SERVNAME ${white}исполняемый файл (${red}$EXEC${white}) не найден ${white}!"
		fi
	else
		echo "${red}Ошибка: ${MAGENTA}SERVNAME ${white}директория (${red}$DIR${white}) не найдена ${white}!"
	fi
}

function stopServer 
{
	CHECK=`ps u -C $EXEC | grep -vc USER`
	if [ $CHECK -eq 0 ]; then
		echo "$DESC в данный момент сервер ${red}не запущен${white}."
	else
		killall $EXEC
		echo "$DESC ${red}остановлен !${white}"
	fi
}

function serverStatus 
{
	CHECK=`ps u -C $EXEC | grep -vc USER`
	if [ $CHECK -eq 0 ]; then
		echo "$DESC в данный момент сервер ${red}не запущен${white}."
	else 
		echo "$DESC ${YELLOW}работает${white}."
	fi
}

# Main
menu()
{
	clear
	Info
	log_t "${white}Добро пожаловать в меню управление сервером ${red}by HackChik"
	Info "- ${YELLOW}1${green} -  ${green}Включить ${white}сервер!"
	Info "- ${YELLOW}2${green} -  ${red}Отключить ${white}сервер!"
	Info "- ${YELLOW}3${green} -  ${YELLOW}Перезагрузить ${white}сервер!"
	Info "- ${YELLOW}4${green} -  ${MAGENTA}Посмотреть статус ${white}сервера!"
	Info "- ${YELLOW}5${green} -  ${CYAN}Выход"
	cp_s
	Info
	read -p "${white}Пожалуйста, введите пункт меню:" case
	case $case in
		1)	startServer ;;
		2)	stopServer ;;
		3)	stopServer
			sleep 1
			startServer ;;
		4)	serverStatus ;;
		5) exit;;
	esac
}
menu